#{{{ Import  
import numpy as np #Numeric computation module
import matplotlib.pyplot as plt #Plot library
ar = np.array
pi=np.pi #pi is used everywhere
import scipy as sp
import scipy.signal as sg
import ltiutils as ltu

#}}}

#{{{ Suspension Transfer Function

Q = 100
w0 = 2*pi*1
m = 30.

#LTI object
b=[1.0]
a=[m, m*w0/Q, m*w0**2]
H = ltu.lti(b,a)

#Bode plot
f = np.logspace(-2,2,1000)
ltu.bode(H, f)

#Poles
H.poles
#}}}

#{{{ Optical Spring

K = 2.0*m*w0**2*ltu.lti([1],[1])

#Feedback
H2 = H/K

#Bode plot
f = np.logspace(-2,2,1000)
ltu.bode(H2, f)

#Poles
H2.poles
#}}}

#{{{ TF for feedback filter

F = 50*ltu.hpf1(1.0)*ltu.lpf1(5.0)*m*w0**2
ltu.bode(F,f)

#}}}

#{{{ Feedback

TF = H2/(-F)
ltu.bode(TF,f)

TF.poles
#}}}

#{{{ Open Loop TF

OPLTF = H2*F

f = np.logspace(-2,3,1000)
ltu.bode(OPLTF,f)
ltu.nyquist(OPLTF,f)

#}}}
