#{{{ Preparation
import sympy as sy
I = sy.I
#}}}

#{{{ Symbol declearation
x,y,z=sy.symbols('x','y','z')
#}}}

#{{{ Algebra

a = (x+1)*(3*x**2+5)
sy.pprint(a)
c = sy.expand(a)
sy.factor(c)

#Solve an algebraic equation a = 0
sy.solve(a,x)

#Partial fraction decomposition
b = (3*x-3) * x**2 * (2*x**2-5*x-3) / (2*x-3)*(x**2+1)
sy.apart(b,x)

#}}}

#{{{ Calculus

#Limit
sy.limit(sy.sin(x)/x, x, 0)
sy.limit(sy.sin(x+1)/x, x, 0)

#Differentiation
sy.diff(x**2,x)
sy.diff(sy.sin(x)/x,x)

#Series expansion
sy.series(sy.sin(x), x, 0, 10)

#Integration
sy.integrate(sy.cos(x)**2 * sy.sin(x), x)

#}}}

#{{{ Printing

sy.pprint(a)
sy.printing.latex(a)
sy.printing.mathml(a)

#}}}

#{{{ Complex algebra

#Define real valued variables
(a,b,c,d) = sy.symbols('abcd', real=True)

e = (a+I*b)/(c+I*d)
f = e.expand(complex=True)
print(f)
print(sy.re(f))
print(sy.im(f))

#Extract numerator and denominator
sy.fraction(e)


#}}}
