import numpy as np
cimport numpy as np

#{{{ Search

def Search(np.ndarray[np.float64_t, ndim=1] a, int t):
    """
    Returns the number of occurrences of t in array a.
    """
    cdef int c=0
    cdef Py_ssize_t ii
    
    for ii in range(len(a)):
        if a[ii] == t:
            c=c+1            
    return c


#}}}

#{{{ acorr

def acorr(np.ndarray[np.float64_t, ndim=1] x, int n):
    cdef np.ndarray[np.float64_t, ndim=1] c = np.empty(n, dtype=np.float64)
    cdef Py_ssize_t ii,jj
    cdef int N = np.size(x)

    for ii in range(n):
        for jj in range(N-ii):
            c[ii]=c[ii]+x[jj]*x[ii+jj]
        c[ii]=c[ii]/(N-ii)
    return c

#}}}
